searchNodes=[{"doc":"Extensible runtime configuration loader with pluggable providers","ref":"Hush.html","title":"Hush","type":"module"},{"doc":"Is the app running in release mode?","ref":"Hush.html#release_mode?/0","title":"Hush.release_mode?/0","type":"function"},{"doc":"Resolve configuration When called with resolve!/0 it will default to all loaded applications' configuration. When called with resolve!/1 with the configuration as an argument it will process that.","ref":"Hush.html#resolve!/0","title":"Hush.resolve!/0","type":"function"},{"doc":"","ref":"Hush.html#resolve!/2","title":"Hush.resolve!/2","type":"function"},{"doc":"This config provider can be attached to your release to run automatically on boot.","ref":"Hush.ConfigProvider.html","title":"Hush.ConfigProvider","type":"module"},{"doc":"Hush relies on providers to resolve values that the consumer requests. You can read here on how to write your own provider.","ref":"Hush.Provider.html","title":"Hush.Provider","type":"behaviour"},{"doc":"","ref":"Hush.Provider.html#c:fetch/1","title":"Hush.Provider.fetch/1","type":"callback"},{"doc":"Fetch a value from a provider","ref":"Hush.Provider.html#fetch/2","title":"Hush.Provider.fetch/2","type":"function"},{"doc":"","ref":"Hush.Provider.html#c:load/1","title":"Hush.Provider.load/1","type":"callback"},{"doc":"Is the provider a valid one?","ref":"Hush.Provider.html#valid?/1","title":"Hush.Provider.valid?/1","type":"function"},{"doc":"","ref":"Hush.Provider.html#t:child_spec/0","title":"Hush.Provider.child_spec/0","type":"type"},{"doc":"Provider to resolve runtime environmental variables","ref":"Hush.Provider.SystemEnvironment.html","title":"Hush.Provider.SystemEnvironment","type":"module"},{"doc":"Replace configuration with provider-aware resolvers.","ref":"Hush.Resolver.html","title":"Hush.Resolver","type":"module"},{"doc":"Substitute {:hush, Hush.Provider, &quot;key&quot;, [options]} present in the the config argument","ref":"Hush.Resolver.html#resolve!/2","title":"Hush.Resolver.resolve!/2","type":"function"},{"doc":"Substitute {:hush, Hush.Provider, &quot;key&quot;, [options]} present in the the config argument.","ref":"Hush.Resolver.html#resolve/2","title":"Hush.Resolver.resolve/2","type":"function"},{"doc":"Hush relies on transformers to post process values after resolving them. You can read here on how to write your own transformer.","ref":"Hush.Transformer.html","title":"Hush.Transformer","type":"behaviour"},{"doc":"","ref":"Hush.Transformer.html#apply/2","title":"Hush.Transformer.apply/2","type":"function"},{"doc":"","ref":"Hush.Transformer.html#c:key/0","title":"Hush.Transformer.key/0","type":"callback"},{"doc":"","ref":"Hush.Transformer.html#c:transform/2","title":"Hush.Transformer.transform/2","type":"callback"},{"doc":"Apply function transformer","ref":"Hush.Transformer.Apply.html","title":"Hush.Transformer.Apply","type":"module"},{"doc":"Utility functions to cast strings to Elixir native types","ref":"Hush.Transformer.Cast.html","title":"Hush.Transformer.Cast","type":"module"},{"doc":"Cast a string to any type. An error is raised on failure.","ref":"Hush.Transformer.Cast.html#to!/2","title":"Hush.Transformer.Cast.to!/2","type":"function"},{"doc":"File writer transformer","ref":"Hush.Transformer.ToFile.html","title":"Hush.Transformer.ToFile","type":"module"},{"doc":"Hush is designed to help developers configure their applications at runtime and in release mode, retrieving configuration from multiple providers, without having to depend on secret files or hardcoded configuration. Documentation can be found at https://hexdocs.pm/hush .","ref":"readme.html","title":"Hush","type":"extras"},{"doc":"Hush can be used to inject configuration that is not known at compile time, such as environmental variables (e.g.: Heroku's PORT env var), sensitive credentials such as your database password, or any other information you need. # config/prod.exs alias Hush.Provider . { AwsSecretsManager , GcpSecretManager , SystemEnvironment } config :app , Web.Endpoint , http : [ port : { :hush , SystemEnvironment , &quot;PORT&quot; , [ cast : :integer ] } ] config :app , App , cdn_url : { :hush , GcpSecretManager , &quot;CDN_DOMAIN&quot; , [ apply : &amp; { :ok , &quot;https://&quot; &lt;&gt; &amp;1 } ] } config :app , App.RedshiftRepo , password : { :hush , AwsSecretsManager , &quot;REDSHIFT_PASSWORD&quot; } Hush resolves configuration from using providers, it ships with a SystemEnvironment provider which reads environmental variables, but multiple providers exist. You can also write your own easily . Provider Description Link SystemEnvironment Reads environmental variables. AwsSecretsManager Load secrets from AWS Secrets Manager . GitHub GcpSecretManager Load secrets from Google Cloud Secret Manager . GitHub","ref":"readme.html#overview","title":"Hush - Overview","type":"extras"},{"doc":"Add hush to your list of dependencies in mix.exs : def deps do [ { :hush , &quot;~&gt; 1.0.1&quot; } ] end Run mix deps.get to install it. Some providers may need to initialize applications or even start processes to function correctly. The providers will be explicit about whether they need to be loaded at startup or not. GcpSecretsManager unlike SystemEnvironment is one such example. To load the provider you need to configure it like so. Note: SystemEnvironment does not need to be loaded at startup. # config/config.exs alias Hush.Providers.GcpSecretManager config :hush , providers : [ GcpSecretManager ]","ref":"readme.html#installation","title":"Hush - Installation","type":"extras"},{"doc":"Hush can be loaded in two ways, at runtime in your application, or as a Config.Provider in release mode. A sample app has been written so you can see how it's configured. Loading at runtime # application.ex def start ( _type , _args ) do Hush . resolve! ( ) end Loading via in release mode To load hush as a config provider, you need to define in your releases in mix.exs . def project do [ # ... releases : [ app : [ config_providers : [ { Hush.ConfigProvider , nil } ] ] ] ] end If you are using Hush in runtime and release mode, make sure to only resolve configuration in non release mode: # application.ex def start ( _ , _ ) do unless Hush . release_mode? ( ) , do : Hush . resolve! ( ) end","ref":"readme.html#usage","title":"Hush - Usage","type":"extras"},{"doc":"Hush will resolve any tuple in the following format into a value. { :hush , Hush.Provider , &quot;key&quot; , options \\\\ [ ] } Hush.Provider can be any module that implements its behaviour. &quot;key&quot; is passed to the provider to retrieve the data. options is a a Keyword list with the following properties: default: any() - If the provider can't find the value, hush will return this value optional: boolean() - By default, Hush will raise an error if it cannot find a value and there's no default, unless you mark it as optional . apply: fun(any()) :: {:ok, any()} | {:error, String.t()} - Apply a function to the value resolved by Hush. cast: :string | :atom | :charlist | :float | :integer | :boolean | :module - You can ask Hush to cast the value to a Elixir native type. to_file: string() - Write the data to the path give in to_file() and return the path. After Hush resolves a value it runs them through Transfomers. Examples By default if a given key is not found by the provider, Hush will raise an error. To prevent this, provide a default or optional: true in the options component of the tuple. Default # config/config.exs alias Hush.Provider.SystemEnvironment config :app , url : { :hush , SystemEnvironment , &quot;HOST&quot; , default : &quot;example.domain&quot; } # result without environmental variable assert &quot;example.domain&quot; == Application . get_env ( :app , :url ) # result with env HOST=production.domain assert &quot;production.domain&quot; == Application . get_env ( :app , :url ) Casting Here we are reading the PORT environmental variable, casting it to an integer and returning it # config/config.exs alias Hush.Provider.SystemEnvironment config :app , port : { :hush , SystemEnvironment , &quot;PORT&quot; , cast : :integer , default : 4000 } # result without environmental variable assert 4000 == Application . get_env ( :app , :url ) # result with env PORT=443 assert 443 == Application . get_env ( :app , :url ) Optional # config/dev.exs alias Hush.Provider.SystemEnvironment config :app , can_be_nil : { :hush , SystemEnvironment , &quot;KEY&quot; , optional : true } # result without environmental variable assert nil == Application . get_env ( :app , :can_be_nil ) # result with env KEY=&quot;is not nil&quot; assert &quot;is not nil&quot; == Application . get_env ( :app , :can_be_nil )","ref":"readme.html#configuration-format","title":"Hush - Configuration format","type":"extras"},{"doc":"By default Hush will fetch secrets from providers concurrently and will save them to a short-lived cache to prevent fetching the same secret multiple times. The defaults for these values are System.schedulers_online/0 for concurrency and 5000ms for concurrency timeouts. These values can be modified with the following configuration: # config/config.exs config :hush , max_concurrency : 10 , timeout : 5000 , # milliseconds","ref":"readme.html#concurrency-cache","title":"Hush - Concurrency &amp; Cache","type":"extras"},{"doc":"By default Hush ships with the following transformers: Hush.Transfomer.Cast : Takes an argument cast and converts a value into a specific type. Hush.Transfomer.ToFile : Takes an arugment to_file and outputs the value into the path provided. It is possible to add more transformers by the following configuration: # config/prod.exs alias Hush.Provider.SystemEnvironment config :hush , transfomers : [ App.Hush.JsonToMapTransfomer ] config :app , allowed_urls : { :hush , SystemEnvironment , &quot;alloweds_urls&quot; , [ json : true ] } It is also possible to override the transforms Hush will process, and the order they will execute in. See below for more information. Writing your own transfomer The currently shipped transfomers are good examples on how to implement transformers. Transformers are executed in order they are defined, first is Cast , next is ToFile and then the ones configured by you, e.g.: # config/prod.exs config :hush , transformers : [ App.Hush.JsonTransformer ] Lets dissect a transformer as an example. A transformer has to implement the Hush.Transformer behaviour, and as such it has to implement the key/0 and transform/2 functions. A transformer is going to be executed if a configuration tuple requests it by passing the value of key/0 into its options. An example is seeing the json parameter being passed into the value configuration. Hush will process any transformers in which their key/0 function returns :json . Once a configuration tuple requests a transfomer, a function transform/2 is called, where the first argument is what is passed as a value of the key/0 (in the example below it would be :abort_on_failure ), and the second argument would be the current value returned by the provider transformed by any previous transformers. # config/prod.exs config :app , value : { :hush , SystemEnvironment , &quot;key&quot; , [ json : :abort_on_failure ] } # lib/app/hush/JsonTransformer.ex defmodule App.Hush.JsonTransformer do @behaviour Hush.Transformer @impl true @spec key ( ) :: :json def key ( ) , do :json @impl true @spec transform ( config :: any ( ) , value :: any ( ) ) :: { :ok , any ( ) } | { :error , String . t ( ) } def transform ( config , value ) do try do Jason . decode! ( value ) rescue error -&gt; case config do :abort_on_failure -&gt; { :error , &quot;Couldn&#39;t convert \#{ value } to json: \#{ error . message } &quot; } _ -&gt; { :ok , nil } end end end end Overriding Transformers The following example woud take a value passed as an environment variable ALLOWED_URLS='[&quot;http://example.com&quot;]' into a file named /tmp/urls.json with the contents [&quot;https://example.com&quot;] , all due to the order in which the transformers are executed and the fact that override_transformers is true . # config/prod.exs config :hush , override_transformers : true , transformers : [ Hush.Transformer.Cast , App.Hush.HttpToHttpsTransformer , App.Hush.JsonTransformer , Hush.Transformer.ToFile , ] config :app , value : { :hush , SystemEnvironment , &quot;ALLOWED_URLS&quot; , [ http_to_https : true , json : true , to_file : &quot;/tmp/urls.json&quot; ] } # lib/app/hush/HttpToHttpsTransfomer.ex defmodule App.HttpToHttpsTransfomer do @behaviour Hush.Transformer @impl true @spec key ( ) :: :http_to_https def key ( ) , do :http_to_https @impl true @spec transform ( config :: any ( ) , value :: any ( ) ) :: { :ok , any ( ) } | { :error , String . t ( ) } def transfomer ( _config , value ) do { :ok , Enum . map ( value , &amp; http_to_https ( &amp;2 ) ) } end def http_to_https ( value ) do Regex . replace ( ~r/^http:/ , value , &quot;https:&quot; ) end end","ref":"readme.html#transfomers","title":"Hush - Transfomers","type":"extras"},{"doc":"Writing your own provider An example provider is Hush.Provider.SystemEnvironment , which reads environmental variables at runtime. Here's an example of how that provider would look in a app configuration. alias Hush.Provider.SystemEnvironment config :app , Web.Endpoint , http : [ port : { :hush , SystemEnvironment , &quot;PORT&quot; , [ cast : :integer , default : 4000 ] } ] This behaviour expects two functions: load ( config :: Keyword . t ( ) ) :: :ok | { :ok , [ child_spec ( ) ] } | { :error , any ( ) } This function is called at startup time, here you can perform any initialization you need, such as loading applications that you depend on. If you need to startup any processes, you can return a list of child_spec() which will be brought up by Hush's supervisor and brought down after hush runs. fetch ( key :: String . t ( ) ) :: { :ok , String . t ( ) } | { :error , :not_found } | { :error , any ( ) } This function is called when hush is resolving a key with you provider. Ensure that you implement a {:error, :not_found} if the value can't be found as hush will replace with it a default one if the user providede one. Note: All values are required by default, so if the user did not supply a default or made it optional, hush will trigger the error, you don't need to handle that use-case. To implement that provider we can use the following code. defmodule Hush.Provider.SystemEnvironment do @moduledoc &quot;&quot;&quot; Provider to resolve runtime environmental variables &quot;&quot;&quot; @behaviour Hush.Provider @impl Hush.Provider @spec load ( config :: Keyword . t ( ) ) :: :ok | { :ok , [ child_spec ( ) ] } | { :error , any ( ) } def load ( _config ) , do : :ok @impl Hush.Provider @spec fetch ( key :: String . t ( ) ) :: { :ok , String . t ( ) } | { :error , :not_found } def fetch ( key ) do case System . get_env ( key ) do nil -&gt; { :error , :not_found } value -&gt; { :ok , value } end end end","ref":"readme.html#providers","title":"Hush - Providers","type":"extras"},{"doc":"Hush Erlang/OTP Elixir &gt;= 1.0.0 &gt;= 21.0.0 &gt;= 1.10.0 &lt;= 0.5.0 &gt;= 20.0.0 &gt;= 1.9.0","ref":"readme.html#compatibility","title":"Hush - Compatibility","type":"extras"},{"doc":"Hush is released under the Apache License 2.0 - see the LICENSE file.","ref":"readme.html#license","title":"Hush - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Display a warning when provider fetching times out","ref":"changelog.html#v1-0-1","title":"Changelog - v1.0.1","type":"extras"},{"doc":"Add support to load processes from providers. Add asynchronous secret loading. Prevent secrets to be fetched more than once. Fixed #7 where a provider error would raise an error rather than returning a good error message.","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"#2 Add Apply Transformer config :app, Web.Endpoint, cdn_url: {:hush, GcpSecretManager, &quot;CDN_DOMAIN&quot;, [apply: &amp;{:ok, &quot;https://&quot; &lt;&gt; &amp;1}]} Add Elixir 1.12 and OTP/24 compatibility Minor CI changes &amp; documentation updates","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"Add hush_aws_secrets_manager Add Elixir 1.11 compatibility Documentation updates","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"Add Transformers to mutate data in runtime.","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Add to_file: String.t() as an option to pipe secret data into a file.","ref":"changelog.html#v0-3-2","title":"Changelog - v0.3.2","type":"extras"},{"doc":"Bug: Traversing non-iterable structs trips the resolver when running as Config.Provider","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Add configuration resolving to lists, maps &amp; tuples Better error messages on resolve failure.","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Maps can be resolved","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Announced public release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]